
static char rcsid[] = "$Id";

#include <stdio.h>
#include <signal.h>
#include <setjmp.h>

#ifdef __STDC__
#include <stdarg.h>
#else
#include <varargs.h>
#endif

#if G_F77_AIX3XLF
#define f77check_	f77check
#define f77call_	f77call
#endif

#define SIZE_BY_LONG 	(1 << 0)
#define SIZE_BY_REF 	(1 << 1)
#define ALL_SIZE 	(1 << 2)

static int	prop;
static int	good;
static jmp_buf	error;

static void
#ifdef __STDC__
handle_signal (int sig)
#else
handle_signal ()
#endif
{
    longjmp (error, 1);
}

#define	get_size(in, prop) \
	((prop & SIZE_BY_LONG) \
	 ? ((prop & SIZE_BY_REF) ? * va_arg (in, long *) : va_arg (in, long)) \
	 : ((prop & SIZE_BY_REF) ? * va_arg (in, short *) : va_arg (in, short)))

void
#ifdef __STDC__
f77check_ (long * a, char b[], long * c, char d[], ...)
#else
f77check_ (a, b, c, d, va_alist)
    long *	a;
    char	b[];
    long *	c;
    char	d[];
    va_dcl
#endif
{
    va_list	in;

#ifdef __STDC__
    va_start(in, d);
#else
    va_start(in);
#endif

    if (prop & ALL_SIZE)
    {
	if (get_size (in, prop) != sizeof (* a))
	{
	    va_end(in);
	    return;
	}
    }

    if (get_size (in, prop) != * a)
    {
	va_end(in);
	return;
    }

    if (prop & ALL_SIZE)
    {
	if (get_size (in, prop) != sizeof (* c))
	{
	    va_end(in);
	    return;
	}
    }

    if (get_size (in, prop) != * c)
    {
	va_end(in);
	return;
    }

    good = 1;
    va_end(in);
}

void
check_f77 (comp)
    char *	comp;
{
    good = 0;

    for (prop = 0; prop <= (SIZE_BY_LONG | SIZE_BY_REF | ALL_SIZE); prop ++)
    {
	if (setjmp (error))
	    continue;

#ifdef SIGABRT
	signal (SIGABRT, handle_signal);
#endif
	signal (SIGSEGV, handle_signal);
	signal (SIGBUS, handle_signal);

	f77call_ ();

	if (good)
	{
	    printf (" -DG_F77_SIZE_BY_LONG=%d", (prop & SIZE_BY_LONG) != 0);
	    printf (" -DG_F77_SIZE_BY_REF=%d", (prop & SIZE_BY_REF) != 0);
	    printf (" -DG_F77_ALL_SIZE=%d", (prop & ALL_SIZE) != 0);
	    printf ("\n");
	    return;
	}
    }

    fprintf (stderr, "unknown F77 calling convention\n");
    exit (1);
}

main (argc, argv)
    int		argc;
    char *	argv[];
{
    check_f77 (argc > 1 ? argv[1] : "f77");
    exit (0);
}

