
static char rcsid[] = "$Id: epsfcom.c,v 1.2 1992/12/25 01:38:09 nakano Exp nakano $";

#include    "g_out.h"
#define     firstg  -2
extern      FIGURE  m_fig;
extern M_CTRL      m_ctrl;
extern float       mat[3][2];
static M_attr      attr;
static float       xoff, yoff;
static int  current_no, retc;
static int  n_frames, first_frame;
static float PAPER_SIZE_X = 549.02;
static float PAPER_SIZE_Y = 795.23;
static float orig[MXFRAME][2];
static float lwidth[] = { 0.2, 0.6, 1.0, 1.4 };
static float acolor[] = { 0.00, 0.14, 0.28, 0.42, 0.56, 0.71, 0.85 };
static FILE    *fp;
static char    *filename, *mode;
FILE    *fopen();

static frame_orig();
static wrt_frame();
static get_mat();
static wrt_fig();
static ps_fig();
static put_cl();
static put_pl();
static put_pg();
static put_tx();
static skip_marker();
static skip_marker_size();
static skip_marker_type();
static skip_marker_color();

/* ================================================================================ */
ps_form()
{
    static float  fw;
    fw = 0.0;
    attr.lw = attr.clw =  1;
    attr.lt = attr.clt =  0;
    attr.ac = attr.cac =  firstg;
    fw = lwidth[ m_ctrl.width - 1 ] / 2;
    fp = fopen( m_ctrl.ofile, "w" );
    if( fp == 0 ) return -1;

    fprintf( fp, "%%!PS-Adobe-2.0 EPSF-2.0\n" );
    fprintf( fp, "%%%%BoundingBox: 0 0 595 841\n" );
    fprintf( fp, "%%%%DocumentsFonts: Times-Roman\n" );
    fprintf( fp, "%%%%EndComments\n" );
    fprintf( fp, "/Times-Roman findfont 12 scalefont setfont\n" );
    fprintf( fp, "/lt {lineto} def\n" );
    fprintf( fp, "/mt {moveto} def\n" );
    fprintf( fp, "/solid_line [] def\n" );
    fprintf( fp, "/fine_dotted_line [1] def\n" );
    fprintf( fp, "/fine_broken_line [2] def\n" );
    fprintf( fp, "/rough_broken_line [3] def\n" );
    fprintf( fp, "/rough_dotted_line [1 4] def\n" );
    fprintf( fp, "/center_line [4 2 1 2] def\n" );
    fprintf( fp, "/phantom_line [4 2 1 2 1 2] def\n" );
    fprintf( fp, "%.2f %.2f mt\n", 22.64 - fw, 22.64 - fw );
    fprintf( fp, "%.2f %.2f lt\n", 22.64 - fw, 817.87 + fw );
    fprintf( fp, "%.2f %.2f lt\n", 571.66 + fw, 817.87 + fw );
    fprintf( fp, "%.2f %.2f lt\n", 571.66 + fw, 22.64 - fw );
    fprintf( fp, "closepath\n" );
    fprintf( fp, "clip\n" );
    fprintf( fp, "newpath\n" );
    fprintf( fp, "22.64 22.64 translate\n" );
    fprintf( fp, "0 setgray\n" );
    fprintf( fp, "1 setlinecap\n" );
    fprintf( fp, "1 setlinejoin\n" );
    fprintf( fp, "0.2 setlinewidth\n" );

    frame_orig();
    n_frames = m_ctrl.frame[0] * m_ctrl.frame[1];
    first_frame = TRUE;
    while( 1 ) {
        for( current_no = 0; current_no < n_frames; current_no++ ) {
            get_mat();
            retc = wrt_fig();
            if( retc == EOF ) break;
        }
        wrt_frame();
        if( retc != EOF ) {
            fprintf( fp, "showpage\n" );
            fprintf( fp, "%.2f %.2f mt\n", 22.64 - fw, 22.64 - fw );
            fprintf( fp, "%.2f %.2f lt\n", 22.64 - fw, 817.87 + fw );
            fprintf( fp, "%.2f %.2f lt\n", 571.66 + fw, 817.87 + fw );
            fprintf( fp, "%.2f %.2f lt\n", 571.66 + fw, 22.64 - fw );
            fprintf( fp, "closepath\n" );
            fprintf( fp, "clip\n" );
            fprintf( fp, "newpath\n" );
            fprintf( fp, "22.64 22.64 translate\n" );
            fprintf( fp, "0 setgray\n" );
            fprintf( fp, "1 setlinecap\n" );
            fprintf( fp, "1 setlinejoin\n" );
            fprintf( fp, "%.1f setlinewidth\n", lwidth[attr.clw-1] );
            attr.clt = 0;
            attr.cac = 0;
        } else {
            fprintf( fp, "showpage\n" );
            fclose( fp );
            break;
        }
    }
	return 0;
}

/*  =============================================================================== */
static frame_orig()
{
    int     n, tate, yoko, ix, iy;

    n = 0;
    if( m_ctrl.vflag ) {                      /* paper tate-oki */
        tate = m_ctrl.frame[0];
        yoko = m_ctrl.frame[1];

        xoff = PAPER_SIZE_X/yoko;
        yoff = PAPER_SIZE_Y/tate;

                                                   /* tate-wari */
        if( m_ctrl.tflow ) {
             for( ix = 0; ix < yoko; ix++ ) {
                for( iy = tate; iy > 0; iy-- ) {
                    orig[n][0] = ix * xoff;
                    orig[n][1] = iy * yoff;
                    n++;
                }
            }
        } else {                                   /* yoko-wari */
            for( iy = tate; iy > 0; iy-- ) {
                for( ix = 0; ix < yoko; ix++ ) {
                    orig[n][0] = ix * xoff;
                    orig[n][1] = iy * yoff;
                    n++;
                }
            }
        }
    } else {                                  /* paper yoko-oki */
        tate = m_ctrl.frame[1];
        yoko = m_ctrl.frame[0];

        xoff = PAPER_SIZE_X/yoko;
        yoff = PAPER_SIZE_Y/tate;
                                                   /* tate-wari */
        if( m_ctrl.tflow ) {
            for( iy = tate; iy > 0; iy-- ) {
                for( ix = yoko; ix > 0; ix-- ) {
                    orig[n][0] = ix * xoff;
                    orig[n][1] = iy * yoff;
                    n++;
                }
            }
        } else {                                   /* yoko-wari */
            for( ix = yoko; ix > 0; ix-- ) {
                for( iy = tate; iy > 0; iy-- ) {
                    orig[n][0] = ix * xoff;
                    orig[n][1] = iy * yoff;
                    n++;
                }
            }
        }
    }
}

/* =============================================================================== */
static wrt_frame()
{
    int     tate, yoko, i;
    float   p[MXPOLYLINE][2], x, y, tatepitch, yokopitch;

    if( attr.clt != 0 )
        fprintf( fp, "solid_line 0 setdash\n" );
        attr.clt = 0;
    /* frame_line_width set */
    if( m_ctrl.width < 0 ) {
        return 0;
    } else if( m_ctrl.width != attr.clw ) {
        fprintf( fp, "2 setlinecap\n" );
        if( m_ctrl.width > 0 && m_ctrl.width <= 4 ) {
            fprintf( fp, "%.1f setlinewidth\n", lwidth[m_ctrl.width-1] );
            attr.clw = m_ctrl.width;
        } else {
            fprintf( fp, "0.2 setlinewidth\n" );
            attr.clw = 1;
        }
    }
    if( m_ctrl.vflag ) {
        tate = m_ctrl.frame[0];
        yoko = m_ctrl.frame[1];
    } else {
        tate = m_ctrl.frame[1];
        yoko = m_ctrl.frame[0];
    }
    tatepitch   = PAPER_SIZE_Y/tate;
    yokopitch   = PAPER_SIZE_X/yoko;

    if ( m_ctrl.device == 'p' ) {
        /* draw tate line */
        p[0][1] = 0.0;
        p[1][1] = PAPER_SIZE_Y;

        for( i = 0; i <= yoko; i++ ) {
            x   = yokopitch * i;

            p[0][0] = p[1][0] = x;
            fprintf( fp, "%.2f %.2f mt\n", p[0][0], p[0][1] );
            fprintf( fp, "%.2f %.2f lt\n", p[1][0], p[1][1] );
            fprintf( fp, "stroke\n" );
        }

        /* draw yoko line */
        p[0][0] = 0.0;
        p[1][0] = PAPER_SIZE_X;

        for( i = 0; i <= tate; i++ ) {
            y   = tatepitch * i;

            p[0][1] = p[1][1] = y;
            fprintf( fp, "%.2f %.2f mt\n", p[0][0], p[0][1] );
            fprintf( fp, "%.2f %.2f lt\n", p[1][0], p[1][1] );
            fprintf( fp, "stroke\n" );
        }
    }
	return 0;
}

/* =============================================================================== */
static get_mat()
{
    int     i, j;
    float   temp;

    for( i = 0; i < 3; i++ ) {
        for( j = 0; j < 2; j++ ) {
            if( i == j )    mat[i][j] = 1.0;
            else            mat[i][j] = 0.0;
        }
    }
    /* rotation */
    if( m_ctrl.vflag == FALSE ) {
        for( i = 0; i < 3; i++ ) {
            temp      = -mat[i][1];
            mat[i][1] =  mat[i][0];
            mat[i][0] =  temp;
        }
    }

    /* map to laser-writer-coord */
    for( i = 0; i < 3; i++ ) {
        mat[i][0] =  mat[i][0]  * MMPERPOINT * m_ctrl.mag;
        mat[i][1] = -mat[i][1]  * MMPERPOINT * m_ctrl.mag;
    }

    /*  translate to frame origin   */
    if( m_ctrl.device =='p' ) {
        mat[2][0] = mat[2][0] + orig[current_no][0];
        mat[2][1] = mat[2][1] + orig[current_no][1];
    } else if( m_ctrl.device =='i' ) {
        if( m_ctrl.vflag == TRUE ) {
            mat[2][0] = mat[2][0] + 0.0;
            mat[2][1] = mat[2][1] + yoff;
        } else {
            mat[2][0] = mat[2][0] + xoff;
            mat[2][1] = mat[2][1] + yoff;
        }
	}
}

/* =============================================================================== */
static wrt_fig()
{
    retc = ps_fig();
    return retc;
}

/* =============================================================================== */
static ps_fig()
{
    int     code;

    while ( ( code = m_inq_code() ) != EOF ) {
        switch ( code ) {
            case  CIRCLE_CODE   : put_cl()      ; break;
            case  POLYLINE_CODE : put_pl()      ; break;
            case  POLYGON_CODE  : put_pg()      ; break;
            case  MARKER_CODE   : skip_marker() ; break;
            case  TEXT_CODE     : put_tx()      ; break;
            case  LINE_WIDTH_CODE   : m_inq_line_width( &attr.lw ) ; break;
            case  LINE_TYPE_CODE    : m_inq_line_type( &attr.lt )  ; break;
            case  LINE_COLOR_CODE   : m_inq_line_color( &attr.lc ) ; break;
            case  MARKER_SIZE_CODE  : skip_marker_size()           ; break;
            case  MARKER_TYPE_CODE  : skip_marker_type()           ; break;
            case  MARKER_COLOR_CODE : skip_marker_color()          ; break;
            case  AREA_COLOR_CODE   : m_inq_area_color( &attr.ac ) ; break;
            case  TEXT_COLOR_CODE   : m_inq_text_color( &attr.tc ) ; break;
            case  CLS_CODE          : if( first_frame )
                                            first_frame = FALSE;
                                      else
                                            return 0;
            default : ; break;
        }
    }
    return EOF;
}

/* ------------------------------------------------------------------------------- */
static put_cl()
{
    int    fill;
    float  center[2], r;

    retc = m_inq_circle( &center[0], &center[1], &r, &fill );
    if( retc != 0 ) return retc;

    do_tran( center );
    r = r * MMPERPOINT * m_ctrl.mag;
                                                    /* circle data set */
    fprintf( fp, "%.2f %.2f %.2f 0 360 arc\n", center[0], center[1], r );

    if( fill ) {                                    /* fill grey set */
        fprintf( fp, "gsave\n" );
        if( attr.ac != attr.cac ) {
            if( attr.ac >= 0 && attr.ac <= 6 ) {
                fprintf( fp, "%.2f setgray\n", acolor[attr.ac] );
            } else {
                fprintf( fp, "1 setgray\n" );
            }                  
        } else if ( attr.ac == firstg && attr.cac == firstg ) {
                fprintf( fp, "1 setgray\n" );
        }
        fprintf( fp, "fill\n" );
        fprintf( fp, "grestore\n" );
        attr.cac = 0;
    }

    if( attr.lt != attr.clt ) {                     /* line type set */
        switch( attr.lt ) {
        case 1 : fprintf( fp, "fine_dotted_line 0 setdash\n" ) ;attr.clt = 1;break;
        case 2 : fprintf( fp, "fine_broken_line 0 setdash\n" ) ;attr.clt = 2;break;
        case 3 : fprintf( fp, "rough_broken_line 0 setdash\n" );attr.clt = 3;break;
        case 4 : fprintf( fp, "rough_dotted_line 0 setdash\n" );attr.clt = 4;break;
        case 5 : fprintf( fp, "center_line 0 setdash\n" )      ;attr.clt = 5;break;
        case 6 : fprintf( fp, "phantom_line 0 setdash\n" )     ;attr.clt = 6;break;
        default : fprintf( fp, "solid_line 0 setdash\n" )      ;attr.clt = 0;break;
        }
    }

    if( attr.lw != attr.clw ) {                     /* line width set */
        if( attr.lw == 0 ) {
            fprintf( fp, "0.2 setlinewidth\n" );
            attr.clw = 1;
        } else if( attr.lw > 0 && attr.lw <= 4 ) {
            fprintf( fp, "%.1f setlinewidth\n", lwidth[attr.lw-1] );
            attr.clw = attr.lw;
        } else {
            fprintf( fp, "1.4 setlinewidth\n" );
            attr.clw = 4;
        }
    }
    fprintf( fp, "stroke\n" );
	return 0;
}

/* ------------------------------------------------------------------------------- */
static put_pl()
{
    int     pn, i;
    float   p[MXPOLYLINE][2];

    retc = m_inq_polyline( &pn, MXPOLYLINE, p );
    if( retc != 0 ) return retc;

    for( i = 0 ; i < pn ; i++ )
        do_tran( p[i] );

    if( attr.lt != attr.clt ) {                     /* line type set */
        switch( attr.lt ) {
        case 1 : fprintf( fp, "fine_dotted_line 0 setdash\n" ) ;attr.clt = 1;break;
        case 2 : fprintf( fp, "fine_broken_line 0 setdash\n" ) ;attr.clt = 2;break;
        case 3 : fprintf( fp, "rough_broken_line 0 setdash\n" );attr.clt = 3;break;
        case 4 : fprintf( fp, "rough_dotted_line 0 setdash\n" );attr.clt = 4;break;
        case 5 : fprintf( fp, "center_line 0 setdash\n" )      ;attr.clt = 5;break;
        case 6 : fprintf( fp, "phantom_line 0 setdash\n" )     ;attr.clt = 6;break;
        default : fprintf( fp, "solid_line 0 setdash\n" )      ;attr.clt = 0;break;
        }
    }

    if( attr.lw != attr.clw ) {                     /* line width set */
        if( attr.lw == 0 ) {
            fprintf( fp, "0.2 setlinewidth\n" );
            attr.clw = 1;
        } else if( attr.lw > 0 && attr.lw <= 4 ) {
            fprintf( fp, "%.1f setlinewidth\n", lwidth[attr.lw-1] );
            attr.clw = attr.lw;
        } else {
            fprintf( fp, "1.4 setlinewidth\n" );
            attr.clw = 4;
        }
    }

    fprintf( fp, "%.2f %.2f mt\n",p[0][0], p[0][1] );  /* polyline data set */
    for( i =1; i < pn; i++ )
        fprintf( fp, "%.2f %.2f lt\n",p[i][0], p[i][1] );
    fprintf( fp, "stroke\n" );
	return 0;
}

/* ------------------------------------------------------------------------------- */
static put_pg()
{
    int     pn, fill, i;
    float   p[MXPOLYGON][2];

    retc = m_inq_polygon( &pn, MXPOLYGON, p, &fill );
    if( retc != 0 ) return retc;

    for( i = 0 ; i < pn ; i++ ) {
        do_tran( p[i] );
    }
    fprintf( fp, "%.2f %.2f mt\n",p[0][0],p[0][1] );   /* polygon data set */
    for( i =1; i < pn; i++ )
        fprintf( fp, "%.2f %.2f lt\n",p[i][0],p[i][1] );
    fprintf( fp, "closepath\n" );

    if( fill ) {                                    /* fill grey set */
        fprintf( fp, "gsave\n" );
        if( attr.ac != attr.cac ) {
            if( attr.ac >= 0 && attr.ac <= 6 ) {
                fprintf( fp, "%.2f setgray\n", acolor[attr.ac] );
            } else {
                fprintf( fp, "1 setgray\n" );
            }
        } else if ( attr.ac == firstg && attr.cac == firstg ) {
                fprintf( fp, "1 setgray\n" );
        }
        fprintf( fp, "fill\n" );
        fprintf( fp, "grestore\n" );
        attr.cac = 0;
    }

    if( attr.lt != attr.clt ) {                     /* line type set */
        switch( attr.lt ) {
        case 1 : fprintf( fp, "fine_dotted_line 0 setdash\n" ) ;attr.clt = 1;break;
        case 2 : fprintf( fp, "fine_broken_line 0 setdash\n" ) ;attr.clt = 2;break;
        case 3 : fprintf( fp, "rough_broken_line 0 setdash\n" );attr.clt = 3;break;
        case 4 : fprintf( fp, "rough_dotted_line 0 setdash\n" );attr.clt = 4;break;
        case 5 : fprintf( fp, "center_line 0 setdash\n" )      ;attr.clt = 5;break;
        case 6 : fprintf( fp, "phantom_line 0 setdash\n" )     ;attr.clt = 6;break;
        default : fprintf( fp, "solid_line 0 setdash\n" )      ;attr.clt = 0;break;
        }
    }

    if( attr.lw != attr.clw ) {                     /* line width set */
        if( attr.lw == 0 ) {
            fprintf( fp, "0.2 setlinewidth\n" );
            attr.clw = 1;
        } else if( attr.lw > 0 && attr.lw <= 4 ) {
            fprintf( fp, "%.1f setlinewidth\n", lwidth[attr.lw-1] );
            attr.clw = attr.lw;
        } else {
            fprintf( fp, "1.4 setlinewidth\n" );
            attr.clw = 4;
        }
    }
    fprintf( fp, "stroke\n" );
	return 0;
}

/* ------------------------------------------------------------------------------- */
static put_tx()
{
    float   head[2];
    char    string[MXTEXTLEN];

    retc = m_inq_text( &head[0], &head[1], string, MXTEXTLEN );
    if( retc != 0 ) return retc;

    do_tran( head );

    if( m_ctrl.vflag == FALSE ) {
        fprintf( fp, "save\n" );
        fprintf( fp, "newpath\n" );
        fprintf( fp, "%.2f %.2f mt\n", head[0], head[1] );
        fprintf( fp, "270 rotate\n" );
        fprintf( fp, "(%s) show\n", string );
        fprintf( fp, "restore\n" );
    } else {
        fprintf( fp, "save\n" );
        fprintf( fp, "%.2f %.2f mt\n", head[0], head[1] );
        fprintf( fp, "(%s) show\n", string );
        fprintf( fp, "restore\n" );
    }
	return 0;
}                                                        

/* ------------------------------------------------------------------------------- */
static skip_marker()
{
    if( m_fig.HDR.CODE != MARKER_CODE ) return -1;
    return getbuf( (char*)&m_fig.D, sizeof( m_fig.D.MM ) );
}

/* ------------------------------------------------------------------------------- */
static skip_marker_size()
{
    if( m_fig.HDR.CODE != MARKER_SIZE_CODE ) return -1;
    retc = getbuf( (char*)&m_fig.D, sizeof( m_fig.D.MS ) );
	return retc;
}

/* ------------------------------------------------------------------------------- */
static skip_marker_type()
{
    if( m_fig.HDR.CODE != MARKER_TYPE_CODE ) return -1;
    retc = getbuf( (char*)&m_fig.D, sizeof( m_fig.D.MT ) );
	return retc;
}

/* ------------------------------------------------------------------------------- */
static skip_marker_color()
{        
    if( m_fig.HDR.CODE != MARKER_COLOR_CODE ) return -1;
    retc = getbuf( (char*)&m_fig.D, sizeof( m_fig.D.MC ) );
	return retc;
}
