
/*
 *	$Id: g_out.h,v 1.1 1992/12/14 06:01:37 nakano Exp nakano $
 */

#ifndef     GOUT
#define     GOUT    1

#include    "medef.h"
#include    "metag.h"

#define     INCH            25.4        /* mm   */
#define     RESOL           240.0       /* dots */
#define     DOTSPERMM      (RESOL/INCH) /* to laser-shot   */
#define     POINT          (INCH/72.0)
#define     MMPERPOINT     (1.0/POINT)  /* to laser-writer */ 
#define     MXPOLYLINE      4096
#define     MXPOLYGON       4096
#define     MXTEXTLEN       256
#define     MXFRAME         16
#define     MXMAG           50.0
#define     MXMK_SIZE       64

typedef struct {
    float   mag;        /* magnitude                */
    int     frame[2];   /* number of frames         */
    int     width;      /* width for frame lines    */
    char    vflag;      /* TRUE if portrait orient. */
    char    tflow;      /* TRUE if vertical flow    */
    char    device;     /* output device type       */
    char    filler;
    char    mfile[128]; /* metafile name            */
    char    ofile[128]; /* output file name         */
} M_CTRL;
typedef struct {
    int     lw,     clw;    /* line width   */
    int     lt,     clt;    /* line type    */
    int     lc,     clc;    /* line color   */
    float   ms,     cms;    /* marker size  */
    int     mt,     cmt;    /* marker type  */
    int     mc,     cmc;    /* marker color */
    int     ac,     cac;    /* area color   */
    int     tc,     ctc;    /* text color   */
	int				cfgc;	/* foreground color */
} M_attr;

#endif
