
static char rcsid[] = "$Id: pictcom.c,v 1.1 1992/12/14 06:01:40 nakano Exp nakano $";

#include    "g_out.h"

#define     PNSIZE		0X0007
#define		CLIP		0X0001
#define		LINE		0X0020
#define		LINEFROM	0X0021
#define     FGCOLOR		0X000E
#define     FRAMEARC	0X0060
#define     FILLARC		0X0064
#define     FRAMEPOLY	0X0070
#define     FILLPOLY	0X0074
#define     LONGTEXT	0X0028
#define     OPENDPIC	0X00ff
#define     TXSIZE		0X000D

extern FIGURE  m_fig;
extern M_CTRL      m_ctrl;
extern float       mat[3][2];
static M_attr      attr;
static float       xoff, yoff;
static long		lcolor, acolor, tcolor;
static int  current_no, retc;
static int  n_frames, first_frame;
static short rx, ry, pnsize[2];
static short PAPER_SIZE_X = 549;
static short PAPER_SIZE_Y = 795;
static short orig[MXFRAME][2];
static short rgn[4];
static short opcode;
static int lwidth[] = { 1, 3, 4, 6, 8 };
static long color[] = { 33, 205, 341, 409, 137, 69, 273, 30 }; 
FILE    *fp, *fopen();
char    *filename, *mode;
static frame_orig();
static wrt_frame();
static get_mat();
static wrt_fig();
static pict_fig();
static put_cl();
static put_pl();
static put_pg();
static put_tx();
static skip_marker();
static skip_marker_size();
static skip_marker_type();
static skip_marker_color();
static int add_apos();

/* ================================================================================ */
pict_form()
{
    char   	buf[128];
	short	filesize, rgnsize;

	struct	{
		char	hdr[512];
		short	picSize;
		short	picFrame[4];
		short	version_op;
		short	version_num;
		short	header_op;
		char	filler[24];
	}	header;

  /* Initialize flags */
	attr.lw = attr.clw =  1;
    attr.lt = attr.clt =  0;
    attr.lc = attr.cfgc =  0;
    attr.ac = 0;
    attr.tc = 0;
	pnsize[0] = pnsize[1] = 1;
	lcolor = acolor = tcolor = 33;

    first_frame =  TRUE;
    frame_orig(); 
    while( 1 ) {      
        for( current_no = 0;  ; current_no++ ) {
            sprintf( buf, "%s%02d", m_ctrl.ofile, current_no );  
            fp = fopen( buf, "w" );
            if( fp == 0 ) return -1;
		/* write to pict header */
			memset( &header, '\0', sizeof(header) );
			header.picSize = 0;
 			header.picFrame[0] = 0;
 			header.picFrame[1] = 0;
 			header.picFrame[2] = ry;
 			header.picFrame[3] = rx;
			header.version_op  = 0x0011;
			header.version_num = 0x02FF;
			header.header_op   = 0x0C00;
			fwrite( &header, sizeof(header), 1, fp );
		/* clip rectangle for frame_size */
			opcode = CLIP;
 	 		fwrite( &opcode, 2, 1, fp );
 	 		rgnsize = 0x0A;
 	 		fwrite( &rgnsize, 2, 1, fp );
 			fwrite( rgn, sizeof(rgn), 1, fp );
            get_mat();
		/* draw primitives */
            retc = wrt_fig();
            wrt_frame();
		/* write EOF to file-end */
			opcode = OPENDPIC;
			fwrite( &opcode, 2, 1, fp );
		/* write to picSize */
			filesize = (short)ftell( fp );
			fseek( fp, 512, 0 ); 
			fwrite( &filesize, sizeof(filesize), 1, fp );
            fclose( fp );
            if( retc == EOF ) break;
        }
        if( retc == EOF ) break;
    }
	return 0;
}

/*  =============================================================================== */
static frame_orig()
{
    int     tate, yoko, i;

        tate = m_ctrl.frame[0];
        yoko = m_ctrl.frame[1];

    if( m_ctrl.vflag ) {                      /* paper tate-oki */
        xoff = PAPER_SIZE_X/yoko;
        yoff = PAPER_SIZE_Y/tate;
    } else {                                  /* paper yoko-oki */
        xoff = PAPER_SIZE_Y/yoko;
        yoff = PAPER_SIZE_X/tate;
    }
    rx   = (short)xoff;
    ry   = (short)yoff;

	rgn[0] = 0;		/*	 set data to reigion to clip  */
	rgn[1] = 0; 
	rgn[2] = ry;
	rgn[3] = rx;
	
	for( i = 0; i < n_frames; i++ )		/* All frame origin equal to */
		orig[i][0] = orig[i][1] = 0;	/* paper origin	on MacDraw2  */
}

/* =============================================================================== */
static wrt_frame()
{
	return 0;
}

/* =============================================================================== */
static get_mat()
{
    int     i, j;

    for( i = 0; i < 3; i++ ) {
        for( j = 0; j < 2; j++ ) {
            if( i == j )    mat[i][j] = 1.0;
            else            mat[i][j] = 0.0;
        }
    }
 
    /* map to MacDraw2-coord */
	for( i = 0; i < 3; i++ ) {
 		mat[i][0] =  mat[i][0]  * MMPERPOINT * m_ctrl.mag;
 		mat[i][1] =  mat[i][1]  * MMPERPOINT * m_ctrl.mag;
 	} 
}
/* =============================================================================== */
static wrt_fig()
{
    retc = pict_fig();
    return retc;
}

/* =============================================================================== */
static pict_fig()
{
    int     code;

    while ( ( code = m_inq_code() ) != EOF ) {
        switch ( code ) {
            case  CIRCLE_CODE   : put_cl()      ; break;
            case  POLYLINE_CODE : put_pl()      ; break;
            case  POLYGON_CODE  : put_pg()      ; break;
            case  MARKER_CODE   : skip_marker() ; break;
            case  TEXT_CODE     : put_tx()      ; break;
            case  LINE_WIDTH_CODE   : m_inq_line_width( &attr.lw ) ; break;
            case  LINE_TYPE_CODE    : m_inq_line_type( &attr.lt )  ; break;
            case  LINE_COLOR_CODE   : m_inq_line_color( &attr.lc ) ; break;
            case  MARKER_SIZE_CODE  : skip_marker_size()           ; break;
            case  MARKER_TYPE_CODE  : skip_marker_type()           ; break;
            case  MARKER_COLOR_CODE : skip_marker_color()          ; break;
            case  AREA_COLOR_CODE   : m_inq_area_color( &attr.ac ) ; break;
            case  TEXT_COLOR_CODE   : m_inq_text_color( &attr.tc ) ; break;
            case  CLS_CODE          : if( first_frame )
                                            first_frame = FALSE;
                                      else {
										opcode = OPENDPIC;
										fwrite( &opcode, 2, 1, fp );
                                        return 0;
									  }
            default : ; break;
        }
    }
    return EOF;
}

/* ------------------------------------------------------------------------------- */
static put_cl()
{
    int		fill;
	short	rect[4], sangle, eangle;
    float	center[2], r;

    retc = m_inq_circle( &center[0], &center[1], &r, &fill );
    if( retc != 0 ) return retc;

    do_tran( center );
    r = r * MMPERPOINT * m_ctrl.mag;

/* set circle data for pict2 */
	rect[0] = (short)center[1]-r;
	rect[1] = (short)center[0]-r;
	rect[2] = (short)center[1]+r;
	rect[3] = (short)center[0]+r;

/* draw fill circle */
 	if( fill ) {
	/* area color set */
		if( attr.ac != attr.cfgc ) {
			opcode = FGCOLOR;
			fwrite( &opcode, 2, 1, fp );
			if( attr.ac >= 0 && attr.ac <= 7 ) {
				acolor = color[attr.ac];
				attr.cfgc = attr.ac;
			} else {
				acolor = color[0];
				attr.cfgc = 0;
			}
			fwrite( &acolor, 4, 1, fp );
		}
 		opcode = FILLARC;
		sangle = 0; eangle = 360;
 		fwrite( &opcode, 2, 1, fp );
 		fwrite( rect, sizeof(rect), 1, fp );
 		fwrite( &sangle, 2, 1, fp );
 		fwrite( &eangle, 2, 1, fp );
	} 

/* line width set */
	if( attr.lw != attr.clw ) { 
		opcode = PNSIZE;
       	fwrite( &opcode, 2, 1, fp );
		if( attr.lw == 0 ) {
			pnsize[0] = pnsize[1] = lwidth[0];
			attr.clw = 0;
		} else if( attr.lw > 0 && attr.lw <= 5 ) {
			pnsize[0] = pnsize[1] = lwidth[attr.lw-1];
			attr.clw = attr.lw;
		} else if( attr.lw > 5 ) {
			pnsize[0] = pnsize[1] = lwidth[4];
			attr.clw = 5;
		}
		fwrite( pnsize, sizeof(pnsize), 1, fp );
	}

/* line color set */
	if( attr.lc != attr.cfgc ) {
		opcode = FGCOLOR;
		fwrite( &opcode, 2, 1, fp );
		if( attr.lc >= 0 && attr.lc <= 7 ) {
			lcolor = color[attr.lc];
			attr.cfgc = attr.lc;
		} else {
			lcolor = color[0];
			attr.cfgc = 0;
		}
		fwrite( &lcolor, 4, 1, fp );
	}

/* line type set */
/*	NO SUPPORT	
 */

/* draw frame circle */
	opcode = FRAMEARC;
	sangle = 0; eangle = 360;
	fwrite( &opcode, 2, 1, fp );
	fwrite( rect, sizeof(rect), 1, fp );
 	fwrite( &sangle, 2, 1, fp );
 	fwrite( &eangle, 2, 1, fp );

	return 0;
}

/* ------------------------------------------------------------------------------- */
static put_pl()
{
    int     pn, i;
    short	s[MXPOLYLINE][2];
    float   p[MXPOLYLINE][2];

    retc = m_inq_polyline( &pn, MXPOLYLINE, p );
    if( retc != 0 ) return retc;

    for( i = 0 ; i < pn ; i++ )
        do_tran( p[i] );

/* line type set */
/*	NO SUPPORT
 */

/* line width set */
	if( attr.lw != attr.clw ) { 
		opcode = PNSIZE;
       	fwrite( &opcode, 2, 1, fp );
		if( attr.lw == 0 ) {
			pnsize[0] = pnsize[1] = lwidth[0];
			attr.clw = 0;
		} else if( attr.lw > 0 && attr.lw <= 5 ) {
			pnsize[0] = pnsize[1] = lwidth[attr.lw-1];
			attr.clw = attr.lw;
		} else if( attr.lw > 5 ) {
			pnsize[0] = pnsize[1] = lwidth[4];
			attr.clw = 5;
		}
		fwrite( pnsize, sizeof(pnsize), 1, fp );
	}

/* line color set */
	if( attr.lc != attr.cfgc ) {
		opcode = FGCOLOR;
		fwrite( &opcode, 2, 1, fp );
		if( attr.lc >= 0 && attr.lc <= 7 ) {
			lcolor = color[attr.lc];
			attr.cfgc = attr.lc;
		} else {
			lcolor = color[0];
			attr.cfgc = 0;
		}
		fwrite( &lcolor, 4, 1, fp );
	}

/* polyline data set */
	opcode = LINE;
	s[0][0] = (short)p[0][0];	/* draw line from first-point to second */
	s[0][1] = (short)p[0][1];
	s[1][0] = (short)p[1][0];
	s[1][1] = (short)p[1][1];
	fwrite( &opcode, 2, 1, fp );
	fwrite( &s[0][1], 2, 1, fp );
	fwrite( &s[0][0], 2, 1, fp );
	fwrite( &s[1][1], 2, 1, fp );
	fwrite( &s[1][0], 2, 1, fp );
	for( i = 2; i < pn; i++ ) {
		opcode = LINEFROM;
		s[i][0] = (short)p[i][0];	/* from second-point to last */
		s[i][1] = (short)p[i][1];
		fwrite( &opcode, 2, 1, fp );
		fwrite( &s[i][1], 2, 1, fp );
		fwrite( &s[i][0], 2, 1, fp );
	}
	return 0;
}

/* ------------------------------------------------------------------------------- */
static put_pg()
{
    int     pn, fill, i;
	short	polysize, rect[4], s[MXPOLYGON][2];
    float   p[MXPOLYGON][2], xmin, xmax, ymin, ymax;

    retc = m_inq_polygon( &pn, MXPOLYGON, p, &fill );
    if( retc != 0 ) return retc;

    for( i = 0 ; i < pn ; i++ ) {
        do_tran( p[i] );
    }

/* polygon data set */
	xmin = xmax = p[0][0];
	ymin = ymax = p[0][1];
	for( i = 1; i < pn; i++ ) {
		if( xmin > p[i][0] ) xmin = p[i][0];
		if( xmax < p[i][0] ) xmax = p[i][0];
		if( ymin > p[i][1] ) ymin = p[i][1];
		if( ymax < p[i][1] ) ymax = p[i][1];
	}
	polysize = 10+(pn+1)*4;		/* rect+polysize(10bytes) and npoints*4bytes */
	rect[0] = (short)ymin;		/* polygon rectangle */
	rect[1] = (short)xmin;
	rect[2] = (short)ymax;
	rect[3] = (short)xmax;

	if( fill ) {
	/* area color set */
		if( attr.ac != attr.cfgc ) {
			opcode = FGCOLOR;
			fwrite( &opcode, 2, 1, fp );
			if( attr.ac >= 0 && attr.ac <= 7 ) {
				acolor = color[attr.ac];
				attr.cfgc = attr.ac;
			} else {
				acolor = color[0];
				attr.cfgc = 0;
			}
			fwrite( &acolor, 4, 1, fp );
		}
		opcode = FILLPOLY;
		fwrite( &opcode, 2, 1, fp );
		fwrite( &polysize, 2, 1, fp );
		fwrite( rect, sizeof(rect), 1, fp );
		for( i = 0; i < pn; i++ ) {
			s[i][0] = (short)p[i][0];
			s[i][1] = (short)p[i][1];
			fwrite( &s[i][1], 2, 1, fp );
			fwrite( &s[i][0], 2, 1, fp );
		}
		fwrite( &s[0][1], 2, 1, fp );
		fwrite( &s[0][0], 2, 1, fp );
	}
	
/* line width set */
	if( attr.lw != attr.clw ) { 
		opcode = PNSIZE;
       	fwrite( &opcode, 2, 1, fp );
		if( attr.lw == 0 ) {
			pnsize[0] = pnsize[1] = lwidth[0];
			attr.clw = 0;
		} else if( attr.lw > 0 && attr.lw <= 5 ) {
			pnsize[0] = pnsize[1] = lwidth[attr.lw-1];
			attr.clw = attr.lw;
		} else if( attr.lw > 5 ) {
			pnsize[0] = pnsize[1] = lwidth[4];
			attr.clw = 6;
		}
		fwrite( pnsize, sizeof(pnsize), 1, fp );
	}

/* line color set */
	if( attr.lc != attr.cfgc ) {
		opcode = FGCOLOR;
		fwrite( &opcode, 2, 1, fp );
		if( attr.lc >= 0 && attr.lc <= 7 ) {
			lcolor = color[attr.lc];
			attr.cfgc = attr.lc;
		} else {
			lcolor = color[0];
			attr.cfgc = 0;
		}
		fwrite( &lcolor, 4, 1, fp );
	}

/* line type set */
/*	NO SUPPORT
 */

/* draw frame_polygon */
	opcode = FRAMEPOLY;
	fwrite( &opcode, 2, 1, fp );
	fwrite( &polysize, 2, 1, fp );
	fwrite( rect, sizeof(rect), 1, fp );
	for( i = 0; i < pn; i++ ) {
		s[i][0] = (short)p[i][0];
		s[i][1] = (short)p[i][1];
		fwrite( &s[i][1], 2, 1, fp );
		fwrite( &s[i][0], 2, 1, fp );
	}
	fwrite( &s[0][1], 2, 1, fp );
	fwrite( &s[0][0], 2, 1, fp );

	return 0;
}

/* ------------------------------------------------------------------------------- */
static put_tx()
{
    float   head[2];
	short	textsize, point[2];
    char    count, string[MXTEXTLEN], work[MXTEXTLEN];

    retc = m_inq_text( &head[0], &head[1], string, MXTEXTLEN );
    if( retc != 0 ) return retc;

    do_tran( head );
	point[0] = (short)head[1];
	point[1] = (short)head[0];

	count = add_apos( string, work );

/* text size set */
	opcode = TXSIZE;
	textsize = 12;
	fwrite( &opcode, 2, 1, fp );
	fwrite( &textsize, 2, 1, fp );

/* text color set */
	if( attr.tc != attr.cfgc ) {
		opcode = FGCOLOR;
		fwrite( &opcode, 2, 1, fp );
		if( attr.tc >= 0 && attr.tc <= 7 ) {
			tcolor = color[attr.tc];
			attr.cfgc = attr.tc;
		} else {
			tcolor = color[0];
			attr.cfgc = 0;
		}
		fwrite( &tcolor, 4, 1, fp );
	}

/* put text command */
	opcode = LONGTEXT;
	fwrite( &opcode, 2, 1, fp );
	fwrite( point, sizeof(point), 1, fp );
	fwrite( &count, 1, 1, fp );
	fwrite( work, count, 1, fp );
	
	return 0;
}                                                        

/* ------------------------------------------------------------------------------- */
static skip_marker()
{
    if( m_fig.HDR.CODE != MARKER_CODE ) return -1;
    return getbuf( (char*)&m_fig.D, sizeof( m_fig.D.MM ) );
}

/* ------------------------------------------------------------------------------- */
static skip_marker_size()
{
    if( m_fig.HDR.CODE != MARKER_SIZE_CODE ) return -1;
    retc = getbuf( (char*)&m_fig.D, sizeof( m_fig.D.MS ) );
	return retc;
}

/* ------------------------------------------------------------------------------- */
static skip_marker_type()
{
    if( m_fig.HDR.CODE != MARKER_TYPE_CODE ) return -1;
    retc = getbuf( (char*)&m_fig.D, sizeof( m_fig.D.MT ) );
	return retc;
}

/* ------------------------------------------------------------------------------- */
static skip_marker_color()
{        
    if( m_fig.HDR.CODE != MARKER_COLOR_CODE ) return -1;
    retc = getbuf( (char*)&m_fig.D, sizeof( m_fig.D.MC ) );
	return retc;
}

/* ------------------------------------------------------------------------------- */
static int add_apos( s, t )  /* add one more apostrophy to draw it */
char    *s, *t;
{
	char    *sp;
	 
	sp = t;
	while( *s != '\0' ) {
		 if( *s == '\'' )
			 *t++ = '\'';
		 *t++ = *s++;
	}
	*t = '\0';
	return t-sp;
}
