
static char rcsid[] = "$Id: g_device.c,v 1.5 1995/05/23 05:26:09 nakano Exp nakano $";

#include "g_private.h"
#include "g_dev_m.h"
#include "g_dev_x.h"

static void
g_device_def (i, dev)
    int		i;
    DEVICE *	dev;
{
    EXTEND_SLOTS (DEVICE_CONTEXT, device, i, G_MAX_N_DEVICES,
		  "g_init : too many devices");

    device -> slots[i] = * dev;
}

void
g_device_init ()
{
    INIT_SLOTS (DEVICE_CONTEXT, device, DEF_N_DEVICES);

    g_device_def (0, & g_m_device);
    g_device_def (1, & g_x_device);

    device -> mask = 0;
}

void
g_device_call (offset, packet)
    int		offset;
    OPAQUE	packet;
{
    int		n_slots = g_context.device -> n_slots;
    G_DEV_MASK	mask = g_context.device -> mask;
    G_DEV_MASK	current = 1;
    int		i;

    for (i = 0; i < n_slots; i ++)
    {

	if (current == 0)
	    break;

	if ((current & mask) != 0)
	{
	    DEVICE *	dev = & g_context.device -> slots[i];
	    PROC *	proc = * (PROC **) ((char *) dev + offset);

	    if (proc)
	        (* proc) (dev, packet);
	}

	current = (current << 1);
    }
}

void
g_device_term ()
{
    int		n_slots = g_context.device -> n_slots;
    int		i;

    for (i = 0; i < n_slots; i ++)
    {
	DEVICE *	dev = & g_context.device -> slots[i];

	if (dev && dev -> terminate)
	    (* dev -> terminate) (dev);
    }
}

void
Cg_device (mask)
    G_DEV_MASK	mask;
{
    int		n_slots;
    G_DEV_MASK	current = 1;
    int		i;

    g_check_init ();
    n_slots = g_context.device -> n_slots;

    for (i = 0; i < n_slots; i ++)
    {
	DEVICE *	dev = & g_context.device -> slots[i];

	if (current == 0)
	    break;

	if ((current & mask) != 0)
	{
	    if (dev)
	    {
		if ((g_context.device -> mask & current) == 0)
		{
		    if (dev -> initialize)
		    {
			if ((* dev -> initialize) (dev))
			    mask &= ~ current;
		    }

		    if ((current & mask) != 0)
		    {
			if (dev -> validate_bw_color)
			    (* dev -> validate_bw_color) (dev);

			if (dev -> validate_line)
			    (* dev -> validate_line) (dev);

			if (dev -> validate_area)
			    (* dev -> validate_area) (dev);

			if (dev -> validate_text)
			    (* dev -> validate_text) (dev);
		    }
		}
	    }
	    else
	    {
		char	message[100];

		sprintf (message, "improper device %d ignored.\n", i);
		g_warning ("g_device", message);

		mask &= ~ current;
	    }
	}

	current = (current << 1);
    }
    g_context.device -> mask = mask;
}

void
F77g_device (mask)
    G_DEV_MASK *	mask;
{
    Cg_device (* mask);
}

void
g_device__ (mask)
    G_DEV_MASK *	mask;
{
    Cg_device (* mask);
}

