
static char rcsid[] = "$Id: g_f_bird_v.c,v 1.4 1995/05/23 05:26:10 nakano Exp nakano $";

#include "g_private.h"
#include "g_bird.h"

static void
do_fake_bird_view (z_bottom, z_top, x_ratio, y_ratio,
		   x_left_std, y_top_std, x_wid_std, y_wid_std,
		   data, n_x, n_y, unit_x, unit_y, direction)
    G_P_REAL	z_bottom, z_top;
    G_P_REAL	x_ratio, y_ratio;
    G_P_POS	x_left_std, y_top_std;
    G_P_DIM	x_wid_std, y_wid_std;
    G_REAL *	data;
    int		n_x, n_y, unit_x, unit_y, direction;
{
    G_P_POS	x, y, dx, dy;
    G_P_REAL	y_to_x, y_to_y;
    G_POS	gx[G_MAX_N_POINTS], gy[G_MAX_N_POINTS];
    int		i, j, k, l;

    g_check_init ();

    if (G_MAX_N_POINTS < n_x || G_MAX_N_POINTS < n_y)
    {
	g_warning ("g_fake_bird_view", "too large data ignored");
	return;
    }

    if (g_start_fake_bird (z_bottom, z_top, x_ratio, y_ratio,
			   x_left_std, y_top_std, x_wid_std, y_wid_std,
			   & y_to_x, & y_to_y, "g_fake_bird_view"))
    {
	return;
    }

    if (direction < 0)
    {
	data += unit_y * (n_y - 1); 
	unit_y = - unit_y;
    }

    dx = 1.0 / (n_x - 1), dy = 1.0 / (n_y - 1);
    x = 0.0, y = 0.0;
    l = 0;

    for (j = 0; j < n_y; j ++)
    {
	gx[j] = FAKE_X (x, y, data[l], y_to_x, y_to_y);
	gy[j] = FAKE_Y (x, y, data[l], y_to_x, y_to_y);
	l += unit_y;
	y += dy;
    }

    SIDE_LINE ();
    Cg_polyline (gx, gy, n_y);

    ROOF_LINE ();
    y = 0.0;
    k = 0;

    for (i = 0; i < n_y; i ++)
    {
	l = k;
	x = 0.0;
	for (j = 0; j < n_x; j ++)
	{
	    gx[j] = FAKE_X (x, y, data[l], y_to_x, y_to_y);
	    gy[j] = FAKE_Y (x, y, data[l], y_to_x, y_to_y);
	    l += unit_x;
	    x += dx;
	}
	Cg_polyline (gx, gy, n_x);
	k += unit_y;
	y += dy;
    }

    x = dx * (n_x - 1), y = 0.0;
    l = unit_x * (n_x - 1);

    for (j = 0; j < n_y; j ++)
    {
	gx[j] = FAKE_X (x, y, data[l], y_to_x, y_to_y);
	gy[j] = FAKE_Y (x, y, data[l], y_to_x, y_to_y);
	l += unit_y;
	y += dy;
    }

    SIDE_LINE ();
    Cg_polyline (gx, gy, n_y);

    g_end_fake_bird ();
}

void
Cg_fake_bird_view (z_bottom, z_top, x_ratio, y_ratio,
		  x_left_std, y_top_std, x_wid_std, y_wid_std,
		  data, n_x, n_y, direction)
    G_P_REAL	z_bottom, z_top;
    G_P_REAL	x_ratio, y_ratio;
    G_P_POS	x_left_std, y_top_std;
    G_P_DIM	x_wid_std, y_wid_std;
    G_REAL *	data;
    int		n_x, n_y, direction;
{
    do_fake_bird_view (z_bottom, z_top, x_ratio, y_ratio,
		       x_left_std, y_top_std, x_wid_std, y_wid_std,
		       data, n_x, n_y, n_y, 1, direction);
}

void
F77g_fake_bird_view (z_bottom, z_top, x_ratio, y_ratio,
	      x_left_std, y_top_std, x_wid_std, y_wid_std,
	      data, n_x, n_y, direction)
    G_REAL	*z_bottom, *z_top;
    G_REAL	*x_ratio, *y_ratio;
    G_POS	*x_left_std, *y_top_std;
    G_DIM	*x_wid_std, *y_wid_std;
    G_REAL	*data;
    int		*n_x, *n_y, *direction;
{
    do_fake_bird_view (*z_bottom, *z_top, *x_ratio, *y_ratio,
		       *x_left_std, *y_top_std, *x_wid_std, *y_wid_std,
		       data, *n_x, *n_y, 1, *n_x, *direction);
}

void
g_fake_bird_view__ (z_bottom, z_top, x_ratio, y_ratio,
	      x_left_std, y_top_std, x_wid_std, y_wid_std,
	      data, n_x, n_y, direction)
    G_REAL	*z_bottom, *z_top;
    G_REAL	*x_ratio, *y_ratio;
    G_POS	*x_left_std, *y_top_std;
    G_DIM	*x_wid_std, *y_wid_std;
    G_REAL	*data;
    int		*n_x, *n_y, *direction;
{
    do_fake_bird_view (*z_bottom, *z_top, *x_ratio, *y_ratio,
		       *x_left_std, *y_top_std, *x_wid_std, *y_wid_std,
		       data, *n_x, *n_y, 1, *n_x, *direction);
}

