
static char rcsid[] = "$Id: g_fake_bird.c,v 1.3 1995/05/23 05:26:09 nakano Exp nakano $";

#include "g_private.h"
#include "g_bird.h"

static SCALE		saved_scale;
static LINE_PROP	saved_line;
static AREA_PROP	saved_area;
static G_POINT		saved_point;
static unsigned long	saved_bw_color_mask;
static G_POINT		bbox[8];

int
g_start_fake_bird (z_bottom, z_top, x_ratio, y_ratio,
		   x_left_std, y_top_std, x_wid_std, y_wid_std,
		   y_to_x, y_to_y, proc)
    G_P_REAL	z_bottom, z_top;
    G_P_REAL	x_ratio, y_ratio;
    G_P_POS	x_left_std, y_top_std;
    G_P_DIM	x_wid_std, y_wid_std;
    G_P_REAL	*y_to_x, *y_to_y;
    char *	proc;
{
    int		i;

    if (x_wid_std < 0.0 || y_wid_std < 0.0 || x_ratio < 0.0
        || 1.0 < x_ratio || y_ratio < 0.0 || 1.0 < y_ratio)
    {
	g_warning (proc, "invalid parameter specified");
	return G_YES;
    }

    saved_scale = * CURRENT (scale);
    saved_line = * CURRENT (line);
    saved_area = * CURRENT (area);
    saved_point = g_context.point;
    saved_bw_color_mask = g_context.bw_color_mask;

    /* the bounding box */

    * y_to_x = 1 / x_ratio - 1;
    * y_to_y = 1 / y_ratio - 1;

    for (i = 0; i < 8; i ++)
    {
	G_POS	x = (i & 1) ? 1.0 : 0.0;
	G_POS	y = (i & 2) ? 1.0 : 0.0;
	G_POS	z = (i & 4) ? z_top : z_bottom;

	bbox[i].x = FAKE_X (x, y, z, * y_to_x, * y_to_y);
	bbox[i].y = FAKE_Y (x, y, z, * y_to_x, * y_to_y);
    }

    /* calculating the scale */

    g_set_scale ((G_POS) 0.0, 1.0 / x_ratio,
		 z_bottom, z_bottom + (z_top - z_bottom) / y_ratio,
		 x_left_std, y_top_std, x_wid_std, y_wid_std);

    /* drawing the bounding box */
    AXIS_LINE ();
    Cg_move (bbox[0].x, bbox[0].y);
    Cg_plot (bbox[1].x, bbox[1].y);
    Cg_plot (bbox[3].x, bbox[3].y);
    Cg_plot (bbox[2].x, bbox[2].y);
    Cg_plot (bbox[0].x, bbox[0].y);

    Cg_move (bbox[2].x, bbox[2].y);
    Cg_plot (bbox[6].x, bbox[6].y);

    Cg_move (bbox[3].x, bbox[3].y);
    Cg_plot (bbox[7].x, bbox[7].y);

    return G_NO;
}

void
g_end_fake_bird ()
{
    AXIS_LINE ();
    Cg_move (bbox[0].x, bbox[0].y);
    Cg_plot (bbox[4].x, bbox[4].y);

    Cg_move (bbox[1].x, bbox[1].y);
    Cg_plot (bbox[5].x, bbox[5].y);

    * CURRENT (scale) = saved_scale;
    * CURRENT (line) = saved_line;
    * CURRENT (area) = saved_area;
    g_context.point = saved_point ;
    g_set_bw_color (saved_bw_color_mask);
    CALL_PROC (validate_line, NULL);
    CALL_PROC (validate_area, NULL);
}

