
/*
 *	$Id: glsc.h,v 1.5 1995/05/23 07:07:33 nakano Exp nakano $
 */

#ifdef G_DOUBLE
typedef double		G_REAL;
#else
typedef float		G_REAL;
#endif

typedef G_REAL		G_POS;
typedef G_REAL		G_DIM;

typedef double		G_P_REAL;
typedef double		G_P_POS;
typedef double		G_P_DIM;

typedef struct
{
    G_POS	x;
    G_POS	y;
}
G_POINT;

#define	G_MAX_TEXT_LENGTH	(256)
#define	G_MAX_N_POINTS		(256)
#define G_MAX_N_SCALES		(100)
#define	G_MAX_N_LINE_PROPS	(100)
#define	G_MAX_N_AREA_PROPS	(100)
#define G_MAX_N_MARKER_PROPS	(100)
#define G_MAX_N_TEXT_PROPS	(100)

typedef	int			G_BOOL;
#define	G_YES			(1)
#define	G_NO			(0)

#define	G_STOP			(-1.0)

typedef int			G_DEV_MASK;
#define G_NONE			(0)
#define G_META			(1 << 0)
#define G_DISP			(1 << 1)
#define G_BOTH			(G_META | G_DISP)

typedef int			G_COLOR;
#define G_COLOR_MIN		(0)
#define G_BLACK			(0)
#define G_RED			(1)
#define G_GREEN			(2)
#define G_BLUE			(3)
#define G_MAGENTA		(4)
#define G_YELLOW		(5)
#define G_CYAN			(6)
#define G_WHITE			(7)
#define G_COLOR_MAX		(7)

typedef int			G_LINE_WIDTH;

typedef int			G_LINE_TYPE;
#define G_LINE_TYPE_MIN		(0)
#define G_LINE_SOLID		(0)
#define G_LINE_DOTS		(1)
#define G_LINE_DASHED		(2)
#define G_LINE_LONG_DASHED	(3)
#define G_LINE_THIN_DOTS	(4)
#define G_LINE_DOT_DASHED	(5)
#define G_LINE_D_DOT_DASHED	(6)
#define G_LINE_RESERVED		(7)
#define G_LINE_TYPE_MAX		(7)

typedef int			G_MARKER_SIZE;

typedef int			G_MARKER_TYPE;
#define G_MARKER_TYPE_MIN	(-4)
#define G_MARKER_X		(-4)
#define G_MARKER_F_TRIANGLE	(-3)
#define G_MARKER_F_BOX		(-2)
#define G_MARKER_F_CIRC		(-1)
#define G_MARKER_STAR		(0)
#define G_MARKER_CIRC		(1)
#define G_MARKER_BOX		(2)
#define G_MARKER_TRIANGLE	(3)
#define G_MARKER_PLUS		(4)
#define G_MARKER_TYPE_MAX	(4)

typedef int			G_FONT;
#define G_FONT_MIN		(0)
#define G_FONT_TIMES_8		(0)
#define G_FONT_TIMES_12		(1)
#define G_FONT_TIMES_18		(2)
#define G_FONT_TIMES_24		(3)
#define G_FONT_SYMBOL_8		(4)
#define G_FONT_SYMBOL_12	(5)
#define G_FONT_SYMBOL_18	(6)
#define G_FONT_SYMBOL_24	(7)
#define G_FONT_MAX		(7)

typedef int			G_SIDE_MODE;
#define G_SIDE_NONE		(0)
#define G_SIDE_X		(1 << 0)
#define G_SIDE_Y		(1 << 1)
#define G_SIDE_BOTH		(G_SIDE_X | G_SIDE_Y)

#ifdef __STDC__
#define G_ARGS(args)	args
#else
#define G_ARGS(args)	()
#endif

#ifndef G_PRIVATE_H
extern void	g_area_color G_ARGS ((G_COLOR color));
extern void	g_bird_view G_ARGS
		    ((G_P_DIM x_wid, G_P_DIM y_wid, G_P_DIM z_wid,
		      G_P_REAL z_bottom, G_P_REAL z_top,
		      G_P_DIM distance, G_P_REAL theta, G_P_REAL phi,
		      G_P_POS x_left_std, G_P_POS y_top_std,
		      G_P_DIM x_wid_std, G_P_DIM y_wid_std,
		      G_REAL * data, int n_x, int n_y, int direction));
extern void	g_box G_ARGS ((G_P_POS x_left, G_P_POS x_right,
			       G_P_POS y_bottom, G_P_POS y_top,
			       G_BOOL edge, G_BOOL fill));
extern void	g_circle G_ARGS
		    ((G_P_POS x, G_P_POS y, G_P_DIM radius_x,
		      G_BOOL edge, G_BOOL fill));
extern void	g_cls G_ARGS ((void));
extern void	g_contln G_ARGS
		    ((G_P_POS x_left, G_P_POS x_right,
		      G_P_POS y_bottom, G_P_POS y_top,
		      G_REAL * data, int nx, int ny, G_P_POS height));
extern void	g_data_plot G_ARGS ((G_P_POS x_left, G_P_POS x_right,
				     G_POS y[], int n));
extern void	g_def_area G_ARGS ((int id, G_COLOR color));
extern void	g_def_line G_ARGS ((int id, G_COLOR color,
				    int width, G_LINE_TYPE type));
extern void	g_def_marker G_ARGS ((int id, G_COLOR color,
				      int size, G_MARKER_TYPE type));
extern void	g_def_scale G_ARGS
		    ((int id, G_P_POS x_left, G_P_POS x_right,
		      G_P_POS y_bottom, G_P_POS y_top,
		      G_P_POS x_left_std, G_P_POS y_top_std,
		      G_P_POS width_std, G_P_POS height_std));
extern void	g_def_text G_ARGS ((int id, G_COLOR color, G_FONT font));
extern void	g_device G_ARGS ((G_DEV_MASK mask));
extern void	g_fake_bird_view G_ARGS
		    ((G_P_REAL z_bottom, G_P_REAL z_top,
		      G_P_REAL x_ratio, G_P_REAL y_ratio,
		      G_P_POS x_left_std, G_P_POS y_top_std,
		      G_P_DIM x_wid_std, G_P_DIM y_wid_std,
		      G_REAL * data, int n_x, int n_y, int direction));
extern void	g_fake_hidden G_ARGS
		    ((G_P_REAL z_bottom, G_P_REAL z_top,
		      G_P_REAL x_ratio, G_P_REAL y_ratio,
		      G_P_POS x_left_std, G_P_POS y_top_std,
		      G_P_DIM x_wid_std, G_P_DIM y_wid_std,
		      G_REAL * data, int n_x, int n_y, int direction,
		      int side_paint, int intv_x, int intv_y));
extern void	g_hidden G_ARGS
		    ((G_P_DIM x_wid, G_P_DIM y_wid, G_P_DIM z_wid,
		      G_P_REAL z_bottom, G_P_REAL z_top,
		      G_P_DIM distance, G_P_REAL theta, G_P_REAL phi,
		      G_P_POS x_left_std, G_P_POS y_top_std,
		      G_P_DIM x_wid_std, G_P_DIM y_wid_std,
		      G_REAL * data, int n_x, int n_y, int direction,
		      int side_paint, int intv_x, int intv_y));
extern void	g_init G_ARGS ((char * file_name, G_P_DIM win_width,
				G_P_DIM win_height));
extern void	g_line_color G_ARGS ((G_COLOR color));
extern void	g_line_type G_ARGS ((G_LINE_TYPE type));
extern void	g_line_width G_ARGS ((G_LINE_WIDTH width));
extern void	g_marker G_ARGS ((G_P_POS x, G_P_POS y));
extern void	g_marker_color G_ARGS ((G_COLOR color));
extern void	g_marker_size G_ARGS ((G_MARKER_SIZE size));
extern void	g_marker_type G_ARGS ((G_MARKER_TYPE type));
extern void	g_move G_ARGS ((G_P_POS x, G_P_POS y));
extern void	g_plot G_ARGS ((G_P_POS x, G_P_POS y));
extern void	g_point G_ARGS ((G_P_POS x, G_P_POS y));
extern void	g_polygon G_ARGS
		    ((G_POS x[], G_POS y[], int n, G_BOOL edge, G_BOOL fill));
extern void	g_polyline G_ARGS ((G_POS x[], G_POS y[], int n));
extern void	g_sel_area G_ARGS ((int id));
extern void	g_sel_line G_ARGS ((int id));
extern void	g_sel_marker G_ARGS ((int id));
extern void	g_sel_scale G_ARGS ((int id));
extern void	g_sel_text G_ARGS ((int id));
extern void	g_sleep G_ARGS ((G_P_REAL time));
extern void	g_term G_ARGS ((void));
extern void	g_text G_ARGS ((G_P_POS x, G_P_POS y, char * string));
extern void	g_text_color G_ARGS ((G_COLOR color));
extern void	g_text_font G_ARGS ((G_FONT font));
#endif /* ! G_PRIVATE_H */

